#include <stdlib.h>
#include <string.h>
#include "global.h"
#include "eth_functions.h"
#include "data_types.h"
#include "canopenmaster.h"
#include "logger.h"
#include "http.h"


int eth_flag;			
/*	0 =	idle
		1 = send
*/

//TESTWEISE.  Spter soll das die Tab fr BDE 
//char Teststring[13];

// ******** Grundlegende Netzwerkfunktionn ********** //

void eth_listen(void)
{
	eth_flag = 0;
	uip_listen(HTONS(500));
	uip_listen(HTONS(80));
}

void eth_reset(void)
{
	uip_stop();
	uip_restart();
}


int eth_send(void)
{
//	char Teststring[13] = "Hallo Welt./n";
	
	struct app_state *s;
	s = (struct app_state *)uip_conn->appstate;
	//s->dataptr = Teststring;
	s->dataptr = message.msg;

	if(uip_connected()){
		s->state = DATA_SENT;
		s->dataleft = strlen(s->dataptr);
		uip_send((void *)s->dataptr, s->dataleft);
		return 0;
	}
	
	if(uip_acked()) {
		s->state = DATA_ACKED;
		if(s->dataleft < uip_mss()){
			uip_close();
			eth_flag = 0;
			return 5;
		}
		s->dataptr += uip_conn->len;
		s->dataleft -= uip_conn->len;
		uip_send((void *)s->dataptr, s->dataleft);
		s->state = DATA_SENT;
		return 0;
	}

	if(uip_rexmit()) {
		uip_send((void *)s->dataptr, s->dataleft);
		return 2;
	}
	
	if(!uip_connected()) return 1;

return 9;	
}




int eth_receive(void)
{
		
		return 0;
}


void write_eeprom_ip(uint8_t ip0, uint8_t ip1, uint8_t ip2, uint8_t ip3)
{
	uip_ipaddr_t IpAddr;
	eeprom_write_byte((uint8_t*)EE_IP0, ip0);
	eeprom_write_byte((uint8_t*)EE_IP1, ip1);
	eeprom_write_byte((uint8_t*)EE_IP2, ip2);
	eeprom_write_byte((uint8_t*)EE_IP3, ip3);
	uip_ipaddr(IpAddr, ip0, ip1, ip2, ip3);									
	uip_sethostaddr(IpAddr);
}

void write_eeprom_hostip(uint8_t ip0, uint8_t ip1, uint8_t ip2, uint8_t ip3)
{
	uip_ipaddr_t IpAddr;
	eeprom_write_byte((uint8_t*)EE_HOSTIP0, ip0);
	eeprom_write_byte((uint8_t*)EE_HOSTIP1, ip1);
	eeprom_write_byte((uint8_t*)EE_HOSTIP2, ip2);
	eeprom_write_byte((uint8_t*)EE_HOSTIP3, ip3);
	uip_ipaddr(IpAddr, ip0, ip1, ip2, ip3);									
	uip_sethostaddr(IpAddr);
}

void write_eeprom_netmask(uint8_t mask0, uint8_t mask1, uint8_t mask2, uint8_t mask3)
{
	uip_ipaddr_t IpAddr;
	eeprom_write_byte((uint8_t*)EE_NETMASK0, mask0);
	eeprom_write_byte((uint8_t*)EE_NETMASK1, mask1);
	eeprom_write_byte((uint8_t*)EE_NETMASK2, mask2);
	eeprom_write_byte((uint8_t*)EE_NETMASK3, mask3);
	uip_ipaddr(IpAddr, mask0, mask1, mask2, mask3);									
	uip_sethostaddr(IpAddr);
}



// ************** STATEMACHINE ***************** //

void statemachine(void) 
{
	if (uip_connected())
	{
		rs232_puts("statemachine connected");
		eth_flag = uipflag_connected;
	}
	else if (uip_newdata() || uip_acked())
	{
		rs232_puts("statemachine new ack");
		switch(uip_conn->lport) 
			{
				case HTONS(500):
				weihensteph_analysis(uip_appdata);
				break;
				
				case HTONS(80):
				http_server(uip_appdata);
				break;
				
				default: break;
		 }
	}
	else if (uip_rexmit())
	{
		rs232_puts("statemachine rexmit");
		//schau ma mal spter
		//uip_abort();
	}
}

// ******************************************** //

/*
int uip_sendstring(void)
{
	char Teststring[13] = "Hallo Welt./n";
	
	struct app_state *s;
	s = (struct app_state *)uip_conn->appstate;
	//s->dataptr = Teststring;
	s->dataptr = Teststring;

	if(uip_connected()){
		s->state = DATA_SENT;
		s->dataleft = strlen(s->dataptr);
		uip_send((void *)s->dataptr, s->dataleft);
		return 0;
	}
	
	if(uip_acked()) {
		s->state = DATA_ACKED;
		if(s->dataleft < uip_mss()){
			uip_close();
			eth_flag = 0;
			return 5;
		}
		s->dataptr += uip_conn->len;
		s->dataleft -= uip_conn->len;
		uip_send((void *)s->dataptr, s->dataleft);
		s->state = DATA_SENT;
		return 0;
	}

	if(uip_rexmit()) {
		uip_send((void *)s->dataptr, s->dataleft);
		return 2;
	}
	
//	if(!uip_connected()) return 1;

return 9;	
}*/

